dev: [![Build Status](https://travis-ci.org/PromenadeSoftware/Parlay.svg?branch=dev)](https://travis-ci.org/PromenadeSoftware/Parlay)
master: [![Build Status](https://travis-ci.org/PromenadeSoftware/Parlay.svg?branch=master)](https://travis-ci.org/PromenadeSoftware/Parlay)

![Parlay Logo](http://uploads.webflow.com/557d0c4ae62c1b7951b5d7ce/569ed5185e991d8d3ac4c5a3_Parlay%20logo.png)


# Parlay: Powerful Development and Testing System for Embedded Device Software

Parlay is software that brings visibility and accessibility to embedded devices. 

It enables:
* Comprehensive test and analysis
* Painless scientific experimentation and investigation
* Automated instrument verification with easy-to-write python scripts
* Secure remote diagnostics and data capture


## Full Documentation

The documentation for Parlay is hosted on [Read the Docs](http://parlay.readthedocs.org). 

## Installation

### Windows

Download and run the Windows Installer exe from our [releases page](https://github.com/PromenadeSoftware/Parlay/releases/latest).


### Linux

#### Dependencies

Parlay requires some basic python development dependencies. Make sure these are installed.

Run the following from a command prompt:
```
sudo apt-get install python python-pip python-dev libffi-dev libssl-dev
```

#### Install via Python Pip

To install Parlay for development only:
```
$ sudo pip install parlay
```

To install the 'secure' version of Parlay:
```
$ sudo pip install parlay[secure]
```

## Examples

See the [Parlay Examples](https://github.com/PromenadeSoftware/ParlayExamples) repository. 

## Help

Check out the #parlay channel on freenode IRC for help

## License

This version of Parlay is released under the GPLv3 License. Contact [Promenade Software](http://promenadesoftware.com) for more information on a commercial license. 

## Contributing

Please read our [contributing guide](https://github.com/PromenadeSoftware/Parlay/blob/master/CONTRIBUTING.md). 

## Copyright

Parlay is Copyright (C) 2015 by Promenade Software, Inc.

